/* enorm.cpp -- compute euclidean norm of vector */
#include "xfloat.h"

xfloat enorm(int n, xfloat x[])
{
	int i;
    xfloat sum;

    sum = x[0] * x[0];
    for (i=1;i<n;i++)
        sum += x[i]*x[i];
	return sqrt(sum);
}

/* compute row norm for column c from row r to row m */

xfloat rownorm(int m, int r, int c, xfloat **x)
{
	int i;
    xfloat sum;

    sum = x[r][c] * x[r][c];
    for (i = r+1;i < m; i++)
                sum += x[i][c] * x[i][c];

	return sqrt(sum);
}

xfloat colnorm(int m, int r, int c, xfloat **x)
{
	int i;
    xfloat sum;

    sum = x[r][c] * x[r][c];
    for (i = c+1;i < m; i++)
                sum += x[r][i] * x[r][i];

	return sqrt(sum);
}

