/* fdjac2.cpp -- calculate approximation to jacobian matrix. */
#include "xfloat.h"

extern xfloat dpmpar[];

void fdjac2(void f(int,int,xfloat *,xfloat *,int *),int m,
    int n,xfloat x[],xfloat *fvec,xfloat **fjac,
    int *iflag,xfloat epsfcn,xfloat wa[])
{
	int i,j;
    xfloat eps,epsmch,h,temp;

	epsmch = (epsfcn > dpmpar[0]) ? epsfcn : dpmpar[0];
	eps = sqrt(epsmch);

	for (j = 0;j < n; j++) {
		temp = x[j];
		if (temp == 0.0) h = eps;
                else h = eps * abs(temp);
		x[j] = temp + h;
		f(m,n,x,wa,iflag);
		if (*iflag < 0) break;
		x[j] = temp;
		for (i = 0;i < m; i++)
			fjac[j][i] = (wa[i] - fvec[i]) / h;
	}
}
